com.io7m.r2.core.debug

## Class R2DebugLineSegment

- java.lang.Object
- - com.io7m.r2.core.debug.R2DebugLineSegment

- All Implemented Interfaces:
    R2DebugLineSegmentType

      @Generated(value={"Immutables.generator","R2DebugLineSegmentType"})
      public final class R2DebugLineSegment
      extends Object
      implements R2DebugLineSegmentType

  A line segment.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `R2DebugLineSegment.Builder` Builds instances of type `R2DebugLineSegment`.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static R2DebugLineSegment.Builder` | `builder()` Creates a builder for `R2DebugLineSegment`.
    `static R2DebugLineSegment` | `copyOf(R2DebugLineSegmentType instance)` Creates an immutable copy of a `R2DebugLineSegmentType` value.
    `boolean` | `equals(Object another)` This instance is equal to all instances of `R2DebugLineSegment` that have equal attribute values.
    `com.io7m.jtensors.parameterized.PVectorI3F<R2SpaceWorldType>` | `from()`
    `com.io7m.jtensors.parameterized.PVectorI4F<R2SpaceRGBAType>` | `fromColor()`
    `int` | `hashCode()` Computes a hash code from attributes: `from`, `fromColor`, `to`, `toColor`.
    `static R2DebugLineSegment` | `of(com.io7m.jtensors.parameterized.PVectorI3F<R2SpaceWorldType> from, com.io7m.jtensors.parameterized.PVectorI4F<R2SpaceRGBAType> fromColor, com.io7m.jtensors.parameterized.PVectorI3F<R2SpaceWorldType> to, com.io7m.jtensors.parameterized.PVectorI4F<R2SpaceRGBAType> toColor)` Construct a new immutable `R2DebugLineSegment` instance.
    `com.io7m.jtensors.parameterized.PVectorI3F<R2SpaceWorldType>` | `to()`
    `com.io7m.jtensors.parameterized.PVectorI4F<R2SpaceRGBAType>` | `toColor()`
    `String` | `toString()` Prints the immutable value `R2DebugLineSegment` with attribute values.
    `R2DebugLineSegment` | `withFrom(com.io7m.jtensors.parameterized.PVectorI3F<R2SpaceWorldType> value)` Copy the current immutable object by setting a value for the `from` attribute.
    `R2DebugLineSegment` | `withFromColor(com.io7m.jtensors.parameterized.PVectorI4F<R2SpaceRGBAType> value)` Copy the current immutable object by setting a value for the `fromColor` attribute.
    `R2DebugLineSegment` | `withTo(com.io7m.jtensors.parameterized.PVectorI3F<R2SpaceWorldType> value)` Copy the current immutable object by setting a value for the `to` attribute.
    `R2DebugLineSegment` | `withToColor(com.io7m.jtensors.parameterized.PVectorI4F<R2SpaceRGBAType> value)` Copy the current immutable object by setting a value for the `toColor` attribute.

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Method Detail

    - #### from

          public com.io7m.jtensors.parameterized.PVectorI3F<R2SpaceWorldType> from()

      Specified by:
        `from` in interface `R2DebugLineSegmentType`
      Returns:
        The world-space position of the start of the line segment

    - #### fromColor

          public com.io7m.jtensors.parameterized.PVectorI4F<R2SpaceRGBAType> fromColor()

      Specified by:
        `fromColor` in interface `R2DebugLineSegmentType`
      Returns:
        The color of the start of the line segment

    - #### to

          public com.io7m.jtensors.parameterized.PVectorI3F<R2SpaceWorldType> to()

      Specified by:
        `to` in interface `R2DebugLineSegmentType`
      Returns:
        The world-space position of the end of the line segment

    - #### toColor

          public com.io7m.jtensors.parameterized.PVectorI4F<R2SpaceRGBAType> toColor()

      Specified by:
        `toColor` in interface `R2DebugLineSegmentType`
      Returns:
        The color of the end of the line segment

    - #### withFrom

          public final R2DebugLineSegment withFrom(com.io7m.jtensors.parameterized.PVectorI3F<R2SpaceWorldType> value)

      Copy the current immutable object by setting a value for the `from` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for from
      Returns:
        A modified copy of the `this` object

    - #### withFromColor

          public final R2DebugLineSegment withFromColor(com.io7m.jtensors.parameterized.PVectorI4F<R2SpaceRGBAType> value)

      Copy the current immutable object by setting a value for the `fromColor` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for fromColor
      Returns:
        A modified copy of the `this` object

    - #### withTo

          public final R2DebugLineSegment withTo(com.io7m.jtensors.parameterized.PVectorI3F<R2SpaceWorldType> value)

      Copy the current immutable object by setting a value for the `to` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for to
      Returns:
        A modified copy of the `this` object

    - #### withToColor

          public final R2DebugLineSegment withToColor(com.io7m.jtensors.parameterized.PVectorI4F<R2SpaceRGBAType> value)

      Copy the current immutable object by setting a value for the `toColor` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for toColor
      Returns:
        A modified copy of the `this` object

    - #### equals

          public boolean equals(Object another)

      This instance is equal to all instances of `R2DebugLineSegment` that have equal attribute values.
      Overrides:
        `equals` in class `Object`
      Returns:
        `true` if `this` is equal to `another` instance

    - #### hashCode

          public int hashCode()

      Computes a hash code from attributes: `from`, `fromColor`, `to`, `toColor`.
      Overrides:
        `hashCode` in class `Object`
      Returns:
        hashCode value

    - #### toString

          public String toString()

      Prints the immutable value `R2DebugLineSegment` with attribute values.
      Overrides:
        `toString` in class `Object`
      Returns:
        A string representation of the value

    - #### of

          public static R2DebugLineSegment of(com.io7m.jtensors.parameterized.PVectorI3F<R2SpaceWorldType> from,
                                              com.io7m.jtensors.parameterized.PVectorI4F<R2SpaceRGBAType> fromColor,
                                              com.io7m.jtensors.parameterized.PVectorI3F<R2SpaceWorldType> to,
                                              com.io7m.jtensors.parameterized.PVectorI4F<R2SpaceRGBAType> toColor)

      Construct a new immutable `R2DebugLineSegment` instance.
      Parameters:
        `from` - The value for the `from` attribute
        `fromColor` - The value for the `fromColor` attribute
        `to` - The value for the `to` attribute
        `toColor` - The value for the `toColor` attribute
      Returns:
        An immutable R2DebugLineSegment instance

    - #### copyOf

          public static R2DebugLineSegment copyOf(R2DebugLineSegmentType instance)

      Creates an immutable copy of a `R2DebugLineSegmentType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
      Parameters:
        `instance` - The instance to copy
      Returns:
        A copied immutable R2DebugLineSegment instance

    - #### builder

          public static R2DebugLineSegment.Builder builder()

      Creates a builder for `R2DebugLineSegment`.
      Returns:
        A new R2DebugLineSegment builder

Copyright © 2016 <code@io7m.com> http://io7m.com